%Innholdet til selveste presentasjon
%Titel page
\begin{frame}[t,plain]
    \titlepage
\end{frame}




\subsection*{Download the PDF}\begin{frame}{Project Repository}
    \begin{figure}
        \centering
        \includegraphics[height = 4.9cm]{assets/kNERwz.png}
        \caption{https://git.app.uib.no/Sander.Wiig/prototyping-generics-in-lfortran}
        \label{fig:qrcode}
    \end{figure}
\end{frame}


\section{The ASR}\subsection{The ASR}\begin{frame}{The ASR}
    \begin{itemize}
        \item \textbf{A}bstract \textbf{S}emantic \textbf{R}epresentation
        \item ASR is a tree structure for representing semantics of LFORTRAN
        \item Similar to C++ IPR
        \item Uses Zephyr ASDL format
        \item See report for details.
    \end{itemize}
\end{frame}

\section{Rewriting the ASR}
\subsection{Requirements}\begin{frame}{Requirements}
    According to Haveraan 2019\footnote{Magne Haveraaen, Jaakko Jarvi, and Damian Rouson. Reflecting on generics for fortran. Technical Report 19-188, J3, https://j3-fortran.org/doc/year/19/19-188.pdf, 2019.}
    \begin{itemize}
        \item Generic arguments should treat intrinsic and derived types the same.
        \item Generic parameters should be types, operations with full prototype declarations or typed values, and type checkable.
        \item It should be possible to nest generic definitions.
        \item When instantiating generic code, it should be possible to rename the defined types.
        \item Reusable naming lists should be supported.
    \end{itemize}
    Signature based generics let us do all this and is also in line with 20xx generics spec.\footnote{j3 Generics Subgroup. Generics formal requirements. Technical Report 22-120r5, J3, https://j3-fortran.org/doc/year/22/22-120r5.txt, March 2022.}
\end{frame}

\subsection{Creating a Shared Type Constructor}\begin{frame}{Creating a Shared Type Constructor}
    \begin{itemize}
        \item Most types share the same parameters.
        \item Can be simplified to a single constructor we call definableType.
        \item definableType links to symbol that defines type specific behavior.
        \item ASR no longer favours intrinsic types.
    \end{itemize}
\end{frame}

\begin{frame}{Creating a Shared Type Constructor}
    We also generalize literals
    \begin{itemize}
        \item We use Strings to store the data.
        \item Not perfect, but good enough for prototyping.
        \item Real implementation should serialize data.
    \end{itemize}
\end{frame}

\subsection{Type Signatures}\begin{frame}{Type Signatures}
    \begin{itemize}
        \item Signatures describe operations on types.
        \item Intrinsic signatures are marked so by their ABI.
        \item See report for examples.
        \item Use modules to add them to Translation unit. Not ideal
    \end{itemize}
\end{frame}

\subsection{Nesting Types}\begin{frame}{Nesting Types}
    \begin{itemize}
        \item FORTRAN doesn't allow nested arrays.
        \item By making array into a type we can allow nesting.
        \item Arrays coexist with Dimensions
    \end{itemize}
\end{frame}

\section{Conclusion}
\subsection{Conclusion}\begin{frame}{Flaws and Errors}
    \begin{itemize}
        \item Data \& Signature storage isn't optimal
        \item Arrays need more work
        \item Fortran classes
    \end{itemize}
\end{frame}

\subsection{Conclusion}
\begin{frame}{Conclusion}
    \begin{itemize}
        \item Project has demonstrated how to implement a signature based generic mechanism.
        \item Project has demonstrated nesting of types, including arrays.
        \item Project has reduced ASR by $\frac{1}{3}$. 
    \end{itemize}
\end{frame}
%===============================================Innholdet til selveste presentasjonen
% i filen EksemplerLaTeX finner du eksempler for hvordan du lager slides jeg har oversatt de viktigste til norsk, resten er en gammel tysk greie, men trenges ikke

